= How do I use Sonar to see code quality in my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://sonar.codehaus.org/ Sonar] is a Maven plugin that can run Cobertura, Checkstyle, PMD, !FindBugs, and some other 
tools to gather metrics. Its strength is in providing a dashboard, trending reports, and drilldowns to help visualize 
the state of a software project's code quality.

== Using Jenkins ==

Using the [http://docs.codehaus.org/display/SONAR/Jenkins+Plugin Jenkins Sonar plugin] is the quickest way to get
Sonar into a continuous integration process. It is already installed and configured in SecureCI™.

It is best to set Sonar to ''Build periodically'', and make sure that your Jenkins project builds periodically in addition to 
any ''Poll SCM'' builds it may do. Sonar keeps data whenever it is invoked, but only displays the data from the last build 
each day. So invoking Sonar on each ''Poll SCM'' build may be wasteful.

For a Maven project in Jenkins, check the ''Sonar'' option in the '''Post-build Actions''' of the '''Configure''' screen.
No further configuration is necessary.

For an Ant build in Jenkins, there is an additional check box labeled ''Check if this project is NOT built with maven 2.''
Checking the box will open a series of options to fill in, representing project data that would normally be specified in
the Maven `pom.xml`. Most of the options should be clear. Here are the values we use for our sample application:

||Sonar maven runtime to use||`maven2.2.1`||
||Organisation id||`com.coveros`||
||Project id||`sample`||	
||Project name||`Sample Application`||
||Project description||`A sample application to exercise SecureCI`||
||Project version||`1.0-SNAPSHOT`||	
||Source directories||`src`||
||Sources encoding||`UTF-8`||
||Compiled sources directory||`build/classes`||
||Java version||`1.6`||

Also check ''Check to reuse reports generated by your build''. For the options in that section, we use:

||Surefire reports path||`build/reports/junit`||
||Cobertura report path||`build/reports/cobertura/coverage.xml`||
||Clover report path||''leave blank''||

== For Maven projects without Jenkins ==

To use Sonar to analyze a Maven project without Jenkins set the following properties your `pom.xml` file or your 
`.m2/settings.xml` file. Setting them in the `pom.xml` sets them for everyone the works on the project, while
setting them in the `.m2/settings.xml` file sets them for all projects for a single user. Which one is right for
you depends on your individual situation.

{{{
#!text/xml
  <properties>
    <sonar.host.url>https://XXX.XXX.XXX.XXX/sonar/</sonar.host.url>
    <sonar.jdbc.url>jdbc:mysql://XXX.XXX.XXX.XXX:3306/sonar?useUnicode=true%26characterEncoding=utf8</sonar.jdbc.url>
    <sonar.jdbc.driver>com.mysql.jdbc.Driver</sonar.jdbc.driver>
    <sonar.jdbc.username>sonar</sonar.jdbc.username>
    <sonar.jdbc.password>somepassword</sonar.jdbc.password>
  </properties>
}}}

where `XXX.XXX.XXX.XXX` is the IP address or hostname of the SecureCI™ server and `somepassword` is the password for the
`sonar` database in MySQL. That password was randomly generated during the first boot, and can be found in 
`<%= node['sonar']['home'] %>/conf/sonar.properties`.

Sonar will collect and analyze metric with the following commands:

{{{
  mvn clean install -Dtest=false -DfailIfNoTests=false
  mvn sonar:sonar
}}}  

== For Ant builds without Jenkins ==

'''Reconsider using Jenkins.''' If we can't convince you to do it the easy way, you'll need to use the 
[http://docs.codehaus.org/display/SONAR/Analyse+with+ANT Sonar Ant task]. 

=== More information ===

 * [//sonar/ Sonar dashboard]
 * [http://docs.codehaus.org/display/SONAR/Documentation Sonar documentation]

<%= node['trac']['wiki']['footer'] %>